clazz) throws MavenException {
+ try {
+ return getPlexusContainer0().lookup(clazz);
+ } catch (ComponentLookupException ex) {
+ throw new MavenException(ex);
+ } catch (PlexusContainerException ex) {
+ throw new IllegalStateException(ex);
+ }
+ }
+
+ private static DefaultPlexusContainer newPlexusContainer() throws PlexusContainerException {
+ final ClassWorld classWorld = new ClassWorld(MAVEN_CORE_REALM_ID, ClassWorld.class.getClassLoader());
+ final ClassRealm realm;
+ try {
+ realm = classWorld.getRealm(MAVEN_CORE_REALM_ID);
+ } catch (NoSuchRealmException e) {
+ throw new PlexusContainerException("Could not lookup required class realm", e);
+ }
+ final ContainerConfiguration mavenCoreCC = new DefaultContainerConfiguration() //
+ .setClassWorld(classWorld) //
+ .setRealm(realm) //
+ .setClassPathScanning(PlexusConstants.SCANNING_INDEX) //
+ .setAutoWiring(true) //
+ .setName("mavenCore"); //$NON-NLS-1$
+
+ final Module logginModule = new AbstractModule() {
+ protected void configure() {
+ bind(ILoggerFactory.class).toInstance(LoggerFactory.getILoggerFactory());
+ }
+ };
+ final Module coreExportsModule = new AbstractModule() {
+ protected void configure() {
+ ClassRealm realm = mavenCoreCC.getRealm();
+ CoreExtensionEntry entry = CoreExtensionEntry.discoverFrom(realm);
+ CoreExports exports = new CoreExports(entry);
+ bind(CoreExports.class).toInstance(exports);
+ }
+ };
+ return new DefaultPlexusContainer(mavenCoreCC, logginModule, coreExportsModule);
+ }
+
+ public synchronized void disposeContainer() {
+ if (plexus != null) {
+ plexus.dispose();
+ }
+ }
+
+ public ClassLoader getProjectRealm(MavenProject project) {
+ ClassLoader classLoader = project.getClassRealm();
+ if (classLoader == null) {
+ classLoader = plexus.getContainerRealm();
+ }
+ return classLoader;
+ }
+
+ public void interpolateModel(MavenProject project, Model model) throws MavenException {
+ ModelBuildingRequest request = new DefaultModelBuildingRequest();
+ request.setUserProperties(project.getProperties());
+ ModelProblemCollector problems = new ModelProblemCollector() {
+ @Override
+ public void add(ModelProblemCollectorRequest req) {
+ }
+ };
+ lookup(ModelInterpolator.class).interpolateModel(model, project.getBasedir(), request, problems);
+ }
+
+ /**
+ * Thread-safe properties copy implementation.
+ *
+ * {@link Properties#entrySet()} iterator is not thread safe and fails with
+ * {@link ConcurrentModificationException} if the source properties "is
+ * structurally modified at any time after the iterator is created". The
+ * solution is to use thread-safe {@link Properties#stringPropertyNames()}
+ * enumerate and copy properties.
+ *
+ * @see https://bugs.eclipse.org/bugs/show_bug.cgi?id=440696
+ * @since 1.6
+ */
+ public static void copyProperties(Properties to, Properties from) {
+ for (String key : from.stringPropertyNames()) {
+ String value = from.getProperty(key);
+ if (value != null) {
+ to.put(key, value);
+ }
+ }
+ }
+
+}
diff --git a/vscode-extensions/commons/commons-maven/src/main/java/org/springframework/ide/vscode/commons/maven/MavenCore.java b/vscode-extensions/commons/commons-maven/src/main/java/org/springframework/ide/vscode/commons/maven/MavenCore.java
new file mode 100644
index 000000000..9caa67074
--- /dev/null
+++ b/vscode-extensions/commons/commons-maven/src/main/java/org/springframework/ide/vscode/commons/maven/MavenCore.java
@@ -0,0 +1,173 @@
+/*******************************************************************************
+ * Copyright (c) 2016 Pivotal, Inc.
+ * All rights reserved. This program and the accompanying materials
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ * Pivotal, Inc. - initial API and implementation
+ *******************************************************************************/
+package org.springframework.ide.vscode.commons.maven;
+
+import java.io.File;
+import java.util.Collection;
+import java.util.Collections;
+import java.util.HashSet;
+import java.util.LinkedHashSet;
+import java.util.Set;
+
+import org.apache.maven.RepositoryUtils;
+import org.apache.maven.artifact.Artifact;
+import org.apache.maven.execution.MavenExecutionRequest;
+import org.apache.maven.model.DependencyManagement;
+import org.apache.maven.project.MavenProject;
+import org.eclipse.aether.DefaultRepositorySystemSession;
+import org.eclipse.aether.RepositorySystemSession;
+import org.eclipse.aether.artifact.ArtifactTypeRegistry;
+import org.eclipse.aether.collection.CollectRequest;
+import org.eclipse.aether.collection.DependencyCollectionException;
+import org.eclipse.aether.graph.DependencyNode;
+import org.eclipse.aether.repository.LocalRepositoryManager;
+import org.eclipse.aether.util.filter.ScopeDependencyFilter;
+import org.eclipse.aether.util.graph.manager.DependencyManagerUtils;
+import org.eclipse.aether.util.graph.transformer.ConflictResolver;
+import org.eclipse.aether.util.graph.transformer.JavaScopeDeriver;
+import org.eclipse.aether.util.graph.transformer.JavaScopeSelector;
+import org.eclipse.aether.util.graph.transformer.NearestVersionSelector;
+import org.eclipse.aether.util.graph.transformer.SimpleOptionalitySelector;
+import org.eclipse.aether.util.graph.visitor.CloningDependencyVisitor;
+import org.eclipse.aether.util.graph.visitor.FilteringDependencyVisitor;
+
+/**
+ * Maven Core functionality
+ *
+ * @author Alex Boyko
+ *
+ */
+public class MavenCore {
+
+ private static MavenCore instance = null;
+
+ private MavenBridge maven = new MavenBridge();
+
+ public static MavenCore getInstance() {
+ if (instance == null) {
+ instance = new MavenCore();
+ }
+ return instance;
+ }
+
+ /**
+ * Creates Maven Project descriptor based on the pom file.
+ *
+ * @param pom The pom file
+ * @return Maven project instance
+ * @throws MavenException
+ */
+ public MavenProject readProject(File pom) throws MavenException {
+ return maven.readProject(pom, maven.createExecutionRequest());
+ }
+
+ /**
+ * Taken from M2E same named method from MavenModelManager
+ *
+ * @param repositorySystem
+ * @param repositorySession
+ * @param mavenProject
+ * @param scope
+ * @return
+ */
+ private DependencyNode readDependencyTree(org.eclipse.aether.RepositorySystem repositorySystem,
+ RepositorySystemSession repositorySession, MavenProject mavenProject, String scope) {
+ DefaultRepositorySystemSession session = new DefaultRepositorySystemSession(repositorySession);
+
+ ConflictResolver transformer = new ConflictResolver(new NearestVersionSelector(), new JavaScopeSelector(),
+ new SimpleOptionalitySelector(), new JavaScopeDeriver());
+ session.setDependencyGraphTransformer(transformer);
+ session.setConfigProperty(ConflictResolver.CONFIG_PROP_VERBOSE, Boolean.toString(true));
+ session.setConfigProperty(DependencyManagerUtils.CONFIG_PROP_VERBOSE, true);
+
+ ArtifactTypeRegistry stereotypes = session.getArtifactTypeRegistry();
+
+ CollectRequest request = new CollectRequest();
+ request.setRequestContext("project"); //$NON-NLS-1$
+ request.setRepositories(mavenProject.getRemoteProjectRepositories());
+
+ for (org.apache.maven.model.Dependency dependency : mavenProject.getDependencies()) {
+ request.addDependency(RepositoryUtils.toDependency(dependency, stereotypes));
+ }
+
+ DependencyManagement depMngt = mavenProject.getDependencyManagement();
+ if (depMngt != null) {
+ for (org.apache.maven.model.Dependency dependency : depMngt.getDependencies()) {
+ request.addManagedDependency(RepositoryUtils.toDependency(dependency, stereotypes));
+ }
+ }
+
+ DependencyNode node;
+ try {
+ node = repositorySystem.collectDependencies(session, request).getRoot();
+ } catch (DependencyCollectionException ex) {
+ node = ex.getResult().getRoot();
+ }
+
+ Collection scopes = new HashSet();
+ Collections.addAll(scopes, Artifact.SCOPE_SYSTEM, Artifact.SCOPE_COMPILE, Artifact.SCOPE_PROVIDED,
+ Artifact.SCOPE_RUNTIME, Artifact.SCOPE_TEST);
+ if (Artifact.SCOPE_COMPILE.equals(scope)) {
+ scopes.remove(Artifact.SCOPE_COMPILE);
+ scopes.remove(Artifact.SCOPE_SYSTEM);
+ scopes.remove(Artifact.SCOPE_PROVIDED);
+ } else if (Artifact.SCOPE_RUNTIME.equals(scope)) {
+ scopes.remove(Artifact.SCOPE_COMPILE);
+ scopes.remove(Artifact.SCOPE_RUNTIME);
+ } else if (Artifact.SCOPE_COMPILE_PLUS_RUNTIME.equals(scope)) {
+ scopes.remove(Artifact.SCOPE_COMPILE);
+ scopes.remove(Artifact.SCOPE_SYSTEM);
+ scopes.remove(Artifact.SCOPE_PROVIDED);
+ scopes.remove(Artifact.SCOPE_RUNTIME);
+ } else {
+ scopes.clear();
+ }
+
+ CloningDependencyVisitor cloner = new CloningDependencyVisitor();
+ node.accept(new FilteringDependencyVisitor(cloner, new ScopeDependencyFilter(null, scopes)));
+ node = cloner.getRootNode();
+
+ return node;
+ }
+
+ /**
+ * Calculates dependency graph for a Maven project provided the scope.
+ *
+ * @param project Maven Project descriptor
+ * @param scope Dependency scope
+ * @return Set of all dependencies including transient ones
+ * @throws MavenException
+ */
+ public Set resolveDependencies(MavenProject project, String scope) throws MavenException {
+ Set artifacts = new LinkedHashSet<>();
+
+ MavenExecutionRequest request = maven.createExecutionRequest();
+ DefaultRepositorySystemSession session = maven.createRepositorySession(request);
+
+ DependencyNode graph = readDependencyTree(maven.lookupComponent(org.eclipse.aether.RepositorySystem.class), session, project, scope);
+ if (graph != null) {
+ RepositoryUtils.toArtifacts(artifacts, graph.getChildren(),
+ Collections.singletonList(project.getArtifact().getId()), null);
+
+ // Maven 2.x quirk: an artifact always points at the local repo,
+ // regardless whether resolved or not
+ LocalRepositoryManager lrm = session.getLocalRepositoryManager();
+ for (Artifact artifact : artifacts) {
+ if (!artifact.isResolved()) {
+ String path = lrm.getPathForLocalArtifact(RepositoryUtils.toArtifact(artifact));
+ artifact.setFile(new File(lrm.getRepository().getBasedir(), path));
+ }
+ }
+ }
+
+ return artifacts;
+ }
+}
diff --git a/vscode-extensions/commons/commons-maven/src/main/java/org/springframework/ide/vscode/commons/maven/MavenException.java b/vscode-extensions/commons/commons-maven/src/main/java/org/springframework/ide/vscode/commons/maven/MavenException.java
new file mode 100644
index 000000000..40dc239cd
--- /dev/null
+++ b/vscode-extensions/commons/commons-maven/src/main/java/org/springframework/ide/vscode/commons/maven/MavenException.java
@@ -0,0 +1,42 @@
+/*******************************************************************************
+ * Copyright (c) 2016 Pivotal, Inc.
+ * All rights reserved. This program and the accompanying materials
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ * Pivotal, Inc. - initial API and implementation
+ *******************************************************************************/
+package org.springframework.ide.vscode.commons.maven;
+
+/**
+ * Wrapper for Maven exceptions
+ *
+ * @author Alex Boyko
+ *
+ */
+public class MavenException extends Exception {
+
+ private static final long serialVersionUID = 1L;
+
+ private Throwable t;
+
+ public MavenException() {
+ super();
+ }
+
+ public MavenException(Throwable t) {
+ super();
+ this.t = t;
+ }
+
+ @Override
+ public String getMessage() {
+ if (t != null) {
+ return t.getMessage();
+ }
+ return super.getMessage();
+ }
+
+}
diff --git a/vscode-extensions/commons/commons-maven/src/test/java/org/springframework/ide/vscode/commons/maven/DependencyTreeTest.java b/vscode-extensions/commons/commons-maven/src/test/java/org/springframework/ide/vscode/commons/maven/DependencyTreeTest.java
new file mode 100644
index 000000000..6c6fc2bbb
--- /dev/null
+++ b/vscode-extensions/commons/commons-maven/src/test/java/org/springframework/ide/vscode/commons/maven/DependencyTreeTest.java
@@ -0,0 +1,75 @@
+package org.springframework.ide.vscode.commons.maven;
+
+/*******************************************************************************
+ * Copyright (c) 2016 Pivotal, Inc.
+ * All rights reserved. This program and the accompanying materials
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ * Pivotal, Inc. - initial API and implementation
+ *******************************************************************************/
+import static org.junit.Assert.*;
+
+import java.io.BufferedReader;
+import java.io.File;
+import java.io.IOException;
+import java.io.InputStream;
+import java.io.InputStreamReader;
+import java.nio.file.Files;
+import java.nio.file.Path;
+import java.nio.file.Paths;
+import java.util.Arrays;
+import java.util.Set;
+import java.util.stream.Collectors;
+
+import org.apache.maven.project.MavenProject;
+import org.junit.Test;
+import org.springframework.ide.vscode.commons.util.ExternalCommand;
+import org.springframework.ide.vscode.commons.util.ExternalProcess;
+
+/**
+ * Tests for comparing maven calculated dependencies with ours
+ *
+ * @author Alex Boyko
+ *
+ */
+public class DependencyTreeTest {
+
+ /**
+ * Build test project if it's not built already
+ * @throws Exception
+ */
+ private static void buildProject(Path testProjectPath) throws Exception {
+ if (!Files.exists(testProjectPath.resolve("classpath.txt"))) {
+ testProjectPath.resolve("mvnw").toFile().setExecutable(true);
+ ExternalProcess process = new ExternalProcess(testProjectPath.toFile(), new ExternalCommand("./mvnw", "clean", "package"), true);
+ if (process.getExitValue() != 0) {
+ throw new RuntimeException("Failed to build test project");
+ }
+ }
+ }
+
+ private static Set readClassPathFile(Path classPathFilePath) throws IOException {
+ InputStream in = Files.newInputStream(classPathFilePath);
+ String text = new BufferedReader(new InputStreamReader(in)).lines().collect(Collectors.joining());
+ Path dir = classPathFilePath.getParent();
+ return Arrays.stream(text.split(File.pathSeparator)).map(dir::resolve).collect(Collectors.toSet());
+ }
+
+ @Test
+ public void mavenTest() throws Exception {
+ Path testProjectPath = Paths.get(DependencyTreeTest.class.getResource("/demo-1").toURI());
+ buildProject(testProjectPath);
+
+ MavenProject project = MavenCore.getInstance().readProject(testProjectPath.resolve("pom.xml").toFile());
+ Set calculatedClassPath = MavenCore.getInstance().resolveDependencies(project, null).stream().map(artifact -> {
+ return Paths.get(artifact.getFile().toURI());
+ }).collect(Collectors.toSet());;
+
+ Set expectedClasspath = readClassPathFile(testProjectPath.resolve("classpath.txt"));
+ assertEquals(expectedClasspath, calculatedClassPath);
+ }
+
+}
diff --git a/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/.mvn/wrapper/maven-wrapper.jar b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/.mvn/wrapper/maven-wrapper.jar
new file mode 100644
index 000000000..5fd4d5023
Binary files /dev/null and b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/.mvn/wrapper/maven-wrapper.jar differ
diff --git a/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/.mvn/wrapper/maven-wrapper.properties b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/.mvn/wrapper/maven-wrapper.properties
new file mode 100644
index 000000000..c954cec91
--- /dev/null
+++ b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/.mvn/wrapper/maven-wrapper.properties
@@ -0,0 +1 @@
+distributionUrl=https://repo1.maven.org/maven2/org/apache/maven/apache-maven/3.3.9/apache-maven-3.3.9-bin.zip
diff --git a/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/mvnw b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/mvnw
new file mode 100755
index 000000000..a1ba1bf55
--- /dev/null
+++ b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/mvnw
@@ -0,0 +1,233 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven2 Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ] ; then
+
+ if [ -f /etc/mavenrc ] ; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ] ; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false;
+darwin=false;
+mingw=false
+case "`uname`" in
+ CYGWIN*) cygwin=true ;;
+ MINGW*) mingw=true;;
+ Darwin*) darwin=true
+ #
+ # Look for the Apple JDKs first to preserve the existing behaviour, and then look
+ # for the new JDKs provided by Oracle.
+ #
+ if [ -z "$JAVA_HOME" ] && [ -L /System/Library/Frameworks/JavaVM.framework/Versions/CurrentJDK ] ; then
+ #
+ # Apple JDKs
+ #
+ export JAVA_HOME=/System/Library/Frameworks/JavaVM.framework/Versions/CurrentJDK/Home
+ fi
+
+ if [ -z "$JAVA_HOME" ] && [ -L /System/Library/Java/JavaVirtualMachines/CurrentJDK ] ; then
+ #
+ # Apple JDKs
+ #
+ export JAVA_HOME=/System/Library/Java/JavaVirtualMachines/CurrentJDK/Contents/Home
+ fi
+
+ if [ -z "$JAVA_HOME" ] && [ -L "/Library/Java/JavaVirtualMachines/CurrentJDK" ] ; then
+ #
+ # Oracle JDKs
+ #
+ export JAVA_HOME=/Library/Java/JavaVirtualMachines/CurrentJDK/Contents/Home
+ fi
+
+ if [ -z "$JAVA_HOME" ] && [ -x "/usr/libexec/java_home" ]; then
+ #
+ # Apple JDKs
+ #
+ export JAVA_HOME=`/usr/libexec/java_home`
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ] ; then
+ if [ -r /etc/gentoo-release ] ; then
+ JAVA_HOME=`java-config --jre-home`
+ fi
+fi
+
+if [ -z "$M2_HOME" ] ; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ] ; do
+ ls=`ls -ld "$PRG"`
+ link=`expr "$ls" : '.*-> \(.*\)$'`
+ if expr "$link" : '/.*' > /dev/null; then
+ PRG="$link"
+ else
+ PRG="`dirname "$PRG"`/$link"
+ fi
+ done
+
+ saveddir=`pwd`
+
+ M2_HOME=`dirname "$PRG"`/..
+
+ # make it fully qualified
+ M2_HOME=`cd "$M2_HOME" && pwd`
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --unix "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --unix "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --unix "$CLASSPATH"`
+fi
+
+# For Migwn, ensure paths are in UNIX format before anything is touched
+if $mingw ; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="`(cd "$M2_HOME"; pwd)`"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="`(cd "$JAVA_HOME"; pwd)`"
+ # TODO classpath?
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="`which javac`"
+ if [ -n "$javaExecutable" ] && ! [ "`expr \"$javaExecutable\" : '\([^ ]*\)'`" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=`which readlink`
+ if [ ! `expr "$readLink" : '\([^ ]*\)'` = "no" ]; then
+ if $darwin ; then
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaExecutable="`cd \"$javaHome\" && pwd -P`/javac"
+ else
+ javaExecutable="`readlink -f \"$javaExecutable\"`"
+ fi
+ javaHome="`dirname \"$javaExecutable\"`"
+ javaHome=`expr "$javaHome" : '\(.*\)/bin'`
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ] ; then
+ if [ -n "$JAVA_HOME" ] ; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ] ; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="`which java`"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ] ; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ] ; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=`cygpath --path --windows "$M2_HOME"`
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=`cygpath --path --windows "$JAVA_HOME"`
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=`cygpath --path --windows "$CLASSPATH"`
+fi
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+ local basedir=$(pwd)
+ local wdir=$(pwd)
+ while [ "$wdir" != '/' ] ; do
+ if [ -d "$wdir"/.mvn ] ; then
+ basedir=$wdir
+ break
+ fi
+ wdir=$(cd "$wdir/.."; pwd)
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' < "$1")"
+ fi
+}
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-$(find_maven_basedir)}
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} "$@"
diff --git a/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/mvnw.cmd b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/mvnw.cmd
new file mode 100644
index 000000000..2b934e89d
--- /dev/null
+++ b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/mvnw.cmd
@@ -0,0 +1,145 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM http://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven2 Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a key stroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM enable echoing my setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_pre.bat" call "%HOME%\mavenrc_pre.bat"
+if exist "%HOME%\mavenrc_pre.cmd" call "%HOME%\mavenrc_pre.cmd"
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+set MAVEN_CMD_LINE_ARGS=%*
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+
+set WRAPPER_JAR="".\.mvn\wrapper\maven-wrapper.jar""
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+%MAVEN_JAVA_EXE% %JVM_CONFIG_MAVEN_PROPS% %MAVEN_OPTS% %MAVEN_DEBUG_OPTS% -classpath %WRAPPER_JAR% "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" %WRAPPER_LAUNCHER% %MAVEN_CMD_LINE_ARGS%
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_post.bat" call "%HOME%\mavenrc_post.bat"
+if exist "%HOME%\mavenrc_post.cmd" call "%HOME%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%" == "on" pause
+
+if "%MAVEN_TERMINATE_CMD%" == "on" exit %ERROR_CODE%
+
+exit /B %ERROR_CODE%
\ No newline at end of file
diff --git a/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/pom.xml b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/pom.xml
new file mode 100644
index 000000000..e01f9f26c
--- /dev/null
+++ b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/pom.xml
@@ -0,0 +1,83 @@
+
+
+ 4.0.0
+
+ com.example
+ demo
+ 0.0.1-SNAPSHOT
+ jar
+
+ demo-1
+ Demo project for Spring Boot
+
+
+ org.springframework.boot
+ spring-boot-starter-parent
+ 1.4.0.RELEASE
+
+
+
+
+ UTF-8
+ UTF-8
+ 1.8
+
+
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
+
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+ org.springframework.boot
+ spring-boot-configuration-processor
+ true
+
+
+ org.springframework.boot
+ spring-boot-starter-actuator
+
+
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-maven-plugin
+
+
+ org.apache.maven.plugins
+ maven-dependency-plugin
+ 2.9
+
+
+ build-classpath
+ generate-sources
+
+ build-classpath
+
+
+
+
+ classpath.txt
+
+
+
+
+
+
+
diff --git a/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/src/main/java/com/example/Demo1Application.java b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/src/main/java/com/example/Demo1Application.java
new file mode 100644
index 000000000..8f39b2fc2
--- /dev/null
+++ b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/src/main/java/com/example/Demo1Application.java
@@ -0,0 +1,12 @@
+package com.example;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+
+@SpringBootApplication
+public class Demo1Application {
+
+ public static void main(String[] args) {
+ SpringApplication.run(Demo1Application.class, args);
+ }
+}
diff --git a/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/src/main/java/com/example/DemoProperties.java b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/src/main/java/com/example/DemoProperties.java
new file mode 100644
index 000000000..f05598d03
--- /dev/null
+++ b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/src/main/java/com/example/DemoProperties.java
@@ -0,0 +1,30 @@
+package com.example;
+
+import org.springframework.boot.context.properties.ConfigurationProperties;
+import org.springframework.stereotype.Component;
+
+@ConfigurationProperties("demo.settings")
+@Component
+public class DemoProperties {
+
+ private String user = "user";
+
+ private long timeout = 3000;
+
+ public String getUser() {
+ return user;
+ }
+
+ public void setUser(String user) {
+ this.user = user;
+ }
+
+ public long getTimeout() {
+ return timeout;
+ }
+
+ public void setTimeout(long timeout) {
+ this.timeout = timeout;
+ }
+
+}
diff --git a/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/src/main/java/com/example/RestApi.java b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/src/main/java/com/example/RestApi.java
new file mode 100644
index 000000000..1a65edaf8
--- /dev/null
+++ b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/src/main/java/com/example/RestApi.java
@@ -0,0 +1,16 @@
+package com.example;
+
+import org.springframework.web.bind.annotation.RequestMapping;
+import org.springframework.web.bind.annotation.ResponseBody;
+import org.springframework.web.bind.annotation.RestController;
+
+@RestController
+public class RestApi {
+
+ @RequestMapping("/hello")
+ @ResponseBody
+ public String hello() {
+ return "hello!";
+ }
+
+}
diff --git a/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/src/main/resources/application.properties b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/src/main/resources/application.properties
new file mode 100644
index 000000000..e69de29bb
diff --git a/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/src/test/java/com/example/Demo1ApplicationTests.java b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/src/test/java/com/example/Demo1ApplicationTests.java
new file mode 100644
index 000000000..ccc49c598
--- /dev/null
+++ b/vscode-extensions/commons/commons-maven/src/test/resources/demo-1/src/test/java/com/example/Demo1ApplicationTests.java
@@ -0,0 +1,16 @@
+package com.example;
+
+import org.junit.Test;
+import org.junit.runner.RunWith;
+import org.springframework.boot.test.context.SpringBootTest;
+import org.springframework.test.context.junit4.SpringRunner;
+
+@RunWith(SpringRunner.class)
+@SpringBootTest
+public class Demo1ApplicationTests {
+
+ @Test
+ public void contextLoads() {
+ }
+
+}
diff --git a/vscode-extensions/commons/pom.xml b/vscode-extensions/commons/pom.xml
index 5892de458..88321ebab 100644
--- a/vscode-extensions/commons/pom.xml
+++ b/vscode-extensions/commons/pom.xml
@@ -17,6 +17,7 @@
commons-java
java-properties
application-properties-metadata
+ commons-maven